<!DOCTYPE html>
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <title>Login</title>

        <link rel="stylesheet" href="./libs/bootstrap-5.1.3/css/bootstrap.min.css">
        <link rel="stylesheet" href="./libs/bootstrap-icons/font/bootstrap-icons.css">
        <link href="./src/main-css.css" rel="stylesheet">

        <script src="./libs/jquery-3.6.0.min.js"></script>
        <script src="./libs/bootstrap-5.1.3/js/bootstrap.min.js"></script>
        <script src="./libs/jquery-validation-1.19.3/dist/jquery.validate.min.js"></script>
        <script src="./libs/crypto-js/crypto-js.js"></script>
        <script src="./libs/crypto-js/md5.js"></script>
        <script type="text/javascript" src="./src/main-js.js"></script>
        <script type="text/javascript">
            $(document).ready(function() {
                $('#regisNewUser').load('../views/modal-user-info.html', function() {
                    $('.input-group-password').on('click', function() {
                        passwordSetUp($(this).closest('.input-group'));
                    });
                    $('#modalUserInfo').find('.modal-title').text('Register');
                });

                $('#formSignIn').validate({
                    rules: {
                        username: {
                            required: true,
                            minlength: 6,
                            maxlength: 12
                        }, password: {
                            required: true,
                            minlength: 6,
                            maxlength: 20
                        }
                    },
                    errorPlacement: function ( error, element ) {
                        element.addClass('error');
                        error.insertAfter(element.closest('.input-group'));
                    }
                });
                $('#formSignIn').on('submit', function() {
                    if ($('#formSignIn').valid()) {
                        var password = ($('#formSignIn').find('input[name="password"]').val() !== '' ? hashPassword($('#formSignIn').find('input[name="password"]').val()) : '');
                        $.ajax({
                            url: 'http://localhost:9392/v1/user/',
                            type: 'get',
                            dataType: 'json',
                            data: $('#formSignIn [name]').not('input[name="password"]').serialize() + '&password=' + password,
                            success: function(result) {
                                $.ajax({
                                    url: './module/set-current-user.php',
                                    type: 'post',
                                    dataType: 'json',
                                    data: { userID: result['id'] },
                                });
                                window.location.href = './controllers/profile.php';
                                return false;
                            }, error: function(e) {
                                alert('Cannot sign in to the website.');
                                console.log(e);
                                return false;
                            }
                        });
                    }
                    return false;
                });
                
            });
        </script>
    </head>
    <body>
        <div id="loading" style="display: none;">
            <div class="cover"></div>
            <div class="spinner-border text-danger" role="status"></div>
        </div>
    	<div class="container-fluid">
            <div class="row" style="justify-content: center; align-items: center; min-height: calc(100vh);">
                <div class="col-12 col-md-3">
                    <div class="card">
                        <form id="formSignIn" class="card-body">
                            <h2 class="mb-3">Login</h2>
                            
                            <div class="row mb-3">
                                <div class="form-group col-12">
                                    <div class="row">
                                        <label class="text-start" for="username">Username</label>
                                        <div class="input-group">
                                            <input type="text" class="form-control" name="username" placeholder="Username"/>
                                        </div>
                                    </div>
                                </div>
                                <div class="form-group col-12">
                                    <div class="row">
                                        <label class="text-start" for="password">Password</label>
                                        <div class="input-group">
                                            <input type="password" class="form-control password" name="password" placeholder="Password"/>
                                            <div class="input-group-password input-group-icon">
                                                <i class="bi bi-eye-slash-fill"></i>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <hr>
                            <div class="col-md-12">
                                <div class="row">
                                    <div class="col-md-12 text-end">
                                        <button type="submit" class="btn btn-dismiss" id="login">Sign In</button>
                                    </div>
                                    <div class="col-md-12 text-end">
                                        <label>Or Sign Up <span style="color: blue;" data-toggle="modal" data-target="#modalUserInfo">HERE</span></label>
                                    </div>
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
            <divi id="regisNewUser">
            </div>
    	</div>
	</body>
</html>